---
title: Clients.claim()
slug: Web/API/Clients/claim
tags:
  - API
  - Clients
  - Experimental
  - Method
  - Reference
  - Service Workers
  - ServiceWorker
  - claim
---
<p>{{APIRef("Service Worker Clients")}}</p>

<p><span class="seoSummary">The <strong><code>claim()</code></strong> method of the {{domxref("Clients")}} interface allows an active service worker to set itself as the {{domxref("ServiceWorkerContainer.controller", "controller")}} for all clients within its {{domxref("ServiceWorkerRegistration.scope", "scope")}}. This triggers a "<code>controllerchange</code>" event on {{domxref("ServiceWorkerContainer","navigator.serviceWorker")}} in any clients that become controlled by this service worker.</span></p>

<p>When a service worker is initially registered, pages won't use it until they next load. The <code>claim()</code> method causes those pages to be controlled immediately. Be aware that this results in your service worker controlling pages that loaded regularly over the network, or possibly via a different service worker.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">await clients.claim();
</pre>

<h3 id="Parameters">Parameters</h3>

<p>None.</p>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("Promise")}} that resolves to <code>undefined</code>.</p>

<h2 id="Example">Example</h2>

<p>The following example uses <code>claim()</code> inside service worker's "<code>activate</code>" event listener so that clients loaded in the same scope do not need to be reloaded before their fetches will go through this service worker.</p>

<pre class="brush: js">self.addEventListener('activate', event =&gt; {
  event.waitUntil(clients.claim());
});</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Service Workers', '#clients-claim', 'claim()')}}</td>
   <td>{{Spec2('Service Workers')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<div>

<p>{{Compat("api.Clients.claim")}}</p>
</div>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/API/ServiceWorker_API/Using_Service_Workers">Using Service Workers</a></li>
 <li><a href="https://developers.google.com/web/fundamentals/instant-and-offline/service-worker/lifecycle">The service worker lifecycle</a></li>
 <li><a href="https://jakearchibald.github.io/isserviceworkerready/">Is ServiceWorker ready?</a></li>
 <li>{{jsxref("Promise", "Promises")}}</li>
 <li>{{domxref("ServiceWorkerGlobalScope.skipWaiting()", "self.skipWaiting()")}} - skip the service worker's waiting phase </li>
</ul>
